
*	----------------------------------------------------------------------
*	Example 4.
*	----------------------------------------------------------------------
display "";
display "";
display "com: Example 4: Vector variable";
display "";
display "";

*	Model M2-1s: Closed 2x2 Tax-Ridden Economy --  Vector Syntax

table bmflow(*,*)  Benchmark flows (in value terms)
		 x	 y	  w	cons
	x      100	       -100
	y	       100     -100
	w			200	-200
	l      -20     -60		  80
	k      -60     -40		 100
	tax    -20	 0		  20

set	i	Goods index  /x, y/
	f	Factors index /l, k/;
alias (i,j)

parameter
    ybar(i)	    Benchmark output levels
    fdbar(f,i)	    Benchmark factor inputs
    cbar(i)	    Benchmark final demand
    pbar(f,i)	    Benchmark factor price
    endow0(f)	    Factor endowments
    txf(f,i)	    Ad-valorem tax rate on sector i inputs
    txo(i)	    Proportioanl tax rate on sector i outputs
    ubar	    Benchmark expenditure;

*	Extract values from the table:
ybar(i)		= bmflow(i,i);
fdbar(f,i)	= -bmflow(f,i);
cbar(i)		= -bmflow(i,"w");
ubar		= sum(i, cbar(i));
endow0(f)	 = bmflow(f,"cons");

txf("l",i)	=  -bmflow("tax",i) / fdbar("l",i);
pbar(f,i)	= 1 + txf(f,i);
txo(i)		= 0;

display ybar, fdbar, cbar;

$ontext

$model:m2_1

$sectors:
  v(i)    ! Activity level (vector variable)
  w       ! Welfare index

$commodities:
  pw      ! Utility price
  p(i)    ! Goods prices
  pf(f)   ! Factor prices

$consumers:
  cons    ! Representative consumer

$prod:v(i) s:1
  o:p(i)  q:ybar(i)       a:cons  t:txo(i)
  i:pf(f) q:fdbar(f,i)    p:pbar(f,i)  a:cons  t:txf(f,i)

$prod:w  s:1
  o:pw    q:(ubar)
  i:p(i)  q:cbar(i)

$demand:cons
  d:pw    q:ubar
  e:pf(f) q:endow0(f)

$offtext

$sysinclude mpsgeset m2_1

m2_1.iterlim = 0;

$include m2_1.gen
solve m2_1 using mcp;

m2_1.iterlim = 10000;

*	----------------------------------------------------------------------
*	Increase the endowment.
display "com: Increase the endowment.";

set	sce	/ sce1*sce10 /;
parameter
    endow(f)
    utility Utility level;
endow(f) = endow0(f);

loop(sce,
    endow0(f) = (1 + ord(sce)/100) * endow(f);
    display endow0;
$include m2_1.gen
    solve m2_1 using mcp;
    utility(sce) = w.l;
);
display utility;

display "com: Program ends here.";

* --------------------
* Local Variables:
* fill-column: 80
* End:

